src/main/java/model/Client.java
package model;

import java.util.List;
import java.util.Objects;

public class Client extends User {
    private String phoneNumber;
    private Integer balance;
    private List<Review> reviewsList;

    public String getPhoneNumber() {
        return phoneNumber;
    }

    public void setPhoneNumber(String phoneNumber) {
        this.phoneNumber = phoneNumber;
    }

    public Integer getBalance() {
        return balance;
    }

    public void setBalance(Integer balance) {
        this.balance = balance;
    }

    public List<Review> getReviewsList() {
        return reviewsList;
    }

    public void setReviewsList(List<Review> reviewsList) {
        this.reviewsList = reviewsList;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof Client)) return false;
        if (!super.equals(o)) return false;
        Client client = (Client) o;
        return phoneNumber.equals(client.phoneNumber) && balance.equals(client.balance);
    }

    @Override
    public int hashCode() {
        return Objects.hash(super.hashCode(), phoneNumber, balance);
    }
}

src/main/java/model/Master.java
package model;

import java.util.List;
import java.util.Map;

public class Master extends User {
    private String nameEN;
    private String surnameEN;
    private String phoneNumber;
    private Double rating;
    private List<Category> categories;
    private Map<String, Map<String, String>> appointments;
    private List<Review> reviewsList;

    public String getNameEN() {
        return nameEN;
    }

    public void setNameEN(String nameEN) {
        this.nameEN = nameEN;
    }

    public String getSurnameEN() {
        return surnameEN;
    }

    public void setSurnameEN(String surnameEN) {
        this.surnameEN = surnameEN;
    }

    public String getFullnameUA() {
        return name + " " + surname;
    }

    public String getFullnameEN() {
        return nameEN + " " + surnameEN;
    }

    public String getPhoneNumber() {
        return phoneNumber;
    }

    public void setPhoneNumber(String phoneNumber) {
        this.phoneNumber = phoneNumber;
    }

    public Double getRating() {
        return Math.round(rating * 10.0) / 10.0;
    }

    public void setRating(Double rating) {
        this.rating = rating;
    }

    public List<Category> getCategories() {
        return categories;
    }

    public void setCategories(List<Category> categories) {
        this.categories = categories;
    }

    public Map<String, Map<String, String>> getAppointments() {
        return appointments;
    }

    public void setAppointments(Map<String, Map<String, String>> appointments) {
        this.appointments = appointments;
    }

    public List<Review> getReviewsList() {
        return reviewsList;
    }

    public void setReviewsList(List<Review> reviewsList) {
        this.reviewsList = reviewsList;
    }

}

src/main/webapp/jsp/client/book-appointment-form.jsp
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ page contentType="text/html;charset=UTF-8" %>
<html>
<head>
    <fmt:setLocale value="${sessionScope.lang}"/>
    <fmt:setBundle basename="content"/>
    <title>
        <fmt:message key="title.book-appointment"/>
    </title>
</head>
<body>
<jsp:include page="../navbar.jsp"/>
<div class="mask d-flex align-items-center mt-5">
    <div class="container h-150">
        <div class="row d-flex justify-content-center align-items-center h-100">
            <div class="col-5 ">
                <div class="card" style="border-radius: 10px;">
                    <div class="card-body p-4 justify-content-center">
                        <h3 class="text-uppercase text-center mb-3">
                            <fmt:message key="header.appointment-details"/>
                        </h3>
                        <form action="${pageContext.request.contextPath}/app" method="post"
                              class="justify-content-center">
                            <input type="hidden" name="command" value="bookAppointment"/>
                            <input type="hidden" name="queryString" value="${pageContext.request.queryString}">
                            <jsp:useBean id="service" scope="request" type="model.Service"/>
                            <jsp:useBean id="master" scope="request" type="model.Master"/>
                            <jsp:useBean id="freeTimeslots" scope="request" type="java.util.Map"/>
                            <div class="container text-center">
                                <div class="form-outline mb-2">

                                    <c:choose>
                                        <c:when test="${sessionScope.lang.equals('uk')}">
                                            <c:set var="masterName" value="${master.fullnameUA}"/>
                                            <c:set var="serviceName" value="${service.nameUA}"/>
                                        </c:when>
                                        <c:when test="${sessionScope.lang.equals('en')}">
                                            <c:set var="masterName" value="${master.fullnameEN}"/>
                                            <c:set var="serviceName" value="${service.nameEN}"/>
                                        </c:when>
                                    </c:choose>

                                    <label for="service" class="form-label">
                                        <fmt:message key="service"/>
                                        <input id="service" type="text" value="${serviceName}" class="form-control mt-3"
                                               readonly>
                                    </label>
                                    <input type="hidden" name="serviceId" value="${service.id}">
                                </div>
                                <div class="form-outline mb-2">
                                    <label for="master" class="form-label">
                                        <fmt:message key="master"/>
                                        <input id="master" type="text" value="${masterName}"
                                               class="form-control mt-3" readonly>
                                    </label>
                                    <input type="hidden" name="masterId" value="${master.id}">
                                </div>
                                <div class="form-outline mb-2">
                                    <label for="price" class="form-label">
                                        <fmt:message key="price"/>
                                        <fmt:message key="currency.uah" var="uah"/>
                                        <input id="price" type="text" value="${service.priceUAH} ${uah}"
                                               class="form-control mt-3"
                                               readonly>
                                    </label>
                                </div>
                                <c:if test="${!freeTimeslots.isEmpty()}">
                                    <div class="form-outline mb-4">
                                        <label for="dateTime" class="form-label fs-5">
                                            <fmt:message key="label.pick-datetime"/>
                                        </label>
                                        <select id="dateTime" name="appointmentId">
                                            <c:forEach var="timeslot" items="${freeTimeslots.entrySet()}">
                                                <option value="${timeslot.getKey()}">
                                                        ${timeslot.getValue()}
                                                </option>
                                            </c:forEach>
                                        </select>
                                    </div>
                                </c:if>

                                <c:if test="${freeTimeslots.isEmpty()}">
                                    <h5 class="mt-3">
                                        <fmt:message key="header.no-available-timeslots"/>
                                    </h5>
                                </c:if>

                                <c:if test="${not empty sessionScope.message}">
                                    <jsp:useBean id="message" scope="session" type="java.lang.String"/>
                                    <div class="alert alert-warning justify-content-center" role="alert">
                                        <fmt:message key="${message}"/>
                                    </div>
                                    <c:remove var="message" scope="session"/>
                                </c:if>

                                <c:if test="${!freeTimeslots.isEmpty()}">
                                    <div class="d-flex justify-content-center">
                                        <fmt:message key="button.book" var="book"/>
                                        <input type="submit"
                                               class="btn btn-block btn-lg text-body btn-outline-primary me-4"
                                               role="button" value="${book}"/>
                                        <a href="${pageContext.request.contextPath}/app?command=viewServices"
                                           class="btn btn-block btn-lg text-body btn-outline-secondary" role="button"
                                           aria-pressed="true">
                                            <fmt:message key="button.cancel"/>
                                        </a>
                                    </div>
                                </c:if>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
</body>
</html>

src/main/webapp/jsp/client/master-info-client.jsp
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ page contentType="text/html;charset=UTF-8" %>
<html>
<head>
    <fmt:setLocale value="${sessionScope.lang}"/>
    <fmt:setBundle basename="content"/>
    <title>
        <fmt:message key="title.master-profile"/>
    </title>
    <link rel="stylesheet" href="${pageContext.request.contextPath}/css/star-rating.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
</head>
<body>
<jsp:include page="../navbar.jsp"/>
<div class="container mt-4">
    <jsp:useBean id="master" scope="request" type="model.Master"/>
    <h3 class="text-center mb-5">
        <fmt:message key="master"/>:
        <c:choose>
            <c:when test="${sessionScope.lang.equals('uk')}">
                ${master.fullnameUA}
            </c:when>
            <c:when test="${sessionScope.lang.equals('en')}">
                ${master.fullnameEN}
            </c:when>
        </c:choose>
    </h3>
    <div class="container mx-auto" style="width: 750px">
        <div class="row">
            <div class="col-8">
                <h5>
                    <fmt:message key="master-categories"/>
                </h5>
                <ul>
                    <c:forEach var="category" items="${master.categories}">
                        <li>
                            <c:choose>
                                <c:when test="${sessionScope.lang.equals('uk')}">
                                    ${category.nameUA}
                                </c:when>
                                <c:when test="${sessionScope.lang.equals('en')}">
                                    ${category.nameEN}
                                </c:when>
                            </c:choose>
                        </li>
                    </c:forEach>
                </ul>
            </div>
            <div class="col-4">
                <h5>
                    <fmt:message key="rating"/>:
                    <c:choose>
                        <c:when test="${master.rating != 0.0}">
                            ${master.rating}
                            <span class="fa fa-star checked"></span>
                        </c:when>
                        <c:otherwise>
                            <fmt:message key="n-a"/>
                        </c:otherwise>
                    </c:choose>
                </h5>
            </div>
        </div>

        <c:if test="${not empty sessionScope.message}">
            <jsp:useBean id="message" scope="session" type="java.lang.String"/>
            <div class="alert alert-success" role="alert">
                <fmt:message key="${message}"/>
            </div>
            <c:remove var="message" scope="session"/>
        </c:if>

        <c:if test="${empty master.reviewsList}">
            <h4 class="text-center mt-4 mb-4">
                <fmt:message key="header.no-reviews"/>
            </h4>
        </c:if>

        <c:if test="${not empty master.reviewsList}">
            <div>
                <h5>
                    <fmt:message key="reviews"/>:
                </h5>
                <c:forEach var="review" items="${master.reviewsList}">
                    <div class="card card-body border border-1 mt-3 mb-3 pb-1">
                        <div class="row">
                            <div class="col-2">
                                <b>
                                    <fmt:message key="rating"/>:
                                </b>
                            </div>
                            <div class="col-10">
                                <c:forEach var="point" begin="1" end="${review.rating}">
                                    <span class="fa fa-star checked"></span>
                                </c:forEach>
                            </div>
                        </div>
                        <div class="row mt-3">
                            <div class="col-2">
                                <b>
                                    <fmt:message key="review"/>:
                                </b>
                            </div>
                            <div class="col-10">
                                <p>${review.text}</p>
                            </div>
                        </div>
                    </div>
                </c:forEach>
            </div>
        </c:if>
        <c:if test="${not empty sessionScope.user}">
            <div class="text-center">

                <button type="button" class="btn btn-outline-info mb-4" data-bs-toggle="modal"
                        data-bs-target="#add-review-modal">
                    <fmt:message key="button.add-review"/>
                </button>

                <div class="modal fade btn-group-vertical" id="add-review-modal" tabindex="-1"
                     aria-labelledby="exampleModalLabel" aria-hidden="true">
                    <div class="modal-dialog modal-dialog-centered">
                        <div class="modal-content">
                            <div class="modal-header">
                                <h5 class="modal-title" id="exampleModalLabel">
                                    <fmt:message key="modal-title.add-review"/>
                                    <c:choose>
                                        <c:when test="${sessionScope.lang.equals('uk')}">
                                            ${master.fullnameUA}
                                        </c:when>
                                        <c:when test="${sessionScope.lang.equals('en')}">
                                            ${master.fullnameEN}
                                        </c:when>
                                    </c:choose>
                                </h5>
                                <button type="button" class="btn-close"
                                        data-bs-dismiss="modal"
                                        aria-label="Close"></button>
                            </div>
                            <div class="modal-body">
                                <form id="add-review" action="${pageContext.request.contextPath}/app" method="post">
                                    <input type="hidden" name="command" value="addReview">
                                    <input type="hidden" name="masterId" value="${master.id}">
                                    <div class="row align-items-center">
                                        <div class="col-2 text-start">
                                            <h5 class="mt-2">
                                                <fmt:message key="rating"/>:
                                            </h5>
                                        </div>
                                        <div class="rating col-10">
                                            <input type="radio" name="rating" value="5" id="5">
                                            <label for="5">☆</label>
                                            <input type="radio" name="rating" value="4" id="4">
                                            <label for="4">☆</label>
                                            <input type="radio" name="rating" value="3" id="3">
                                            <label for="3">☆</label>
                                            <input type="radio" name="rating" value="2" id="2">
                                            <label for="2">☆</label>
                                            <input type="radio" name="rating" value="1" id="1">
                                            <label for="1">☆</label>
                                        </div>
                                    </div>
                                    <div class="text-start">
                                        <label for="feedback" class="form-label h5 mt-3">
                                            <fmt:message key="review"/>:
                                        </label>
                                        <textarea class="form-control" id="feedback" name="feedback" maxlength="255"
                                                  rows="3"></textarea>
                                    </div>
                                </form>
                            </div>
                            <div class="modal-footer">
                                <button type="button" class="btn btn-secondary"
                                        data-bs-dismiss="modal">
                                    <fmt:message key="button.close"/>
                                </button>
                                <button type="submit" form="add-review"
                                        class="btn btn-primary">
                                    <fmt:message key="button.submit"/>
                                </button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </c:if>
    </div>
</div>
</body>
</html>

src/main/webapp/jsp/client/masters-list.jsp
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ page contentType="text/html;charset=UTF-8" %>
<html>
<head>
    <fmt:setLocale value="${sessionScope.lang}"/>
    <fmt:setBundle basename="content"/>
    <title>
        <fmt:message key="masters"/>
    </title>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <link rel="stylesheet" href="${pageContext.request.contextPath}/css/star-rating.css">
</head>
<body>
<jsp:include page="../navbar.jsp"/>
<div class="container start-20 end-20">
    <div class="card text-center pt-2 bg-light">
        <form action="${pageContext.request.contextPath}/app" method="get" class="form-inline">
            <input type="hidden" name="command" value="viewMasters">
            <div class="row align-items-center">
                <div class="col">
                    <fmt:message key="sort-by"/>
                </div>
                <div class="col">
                    <ul class="list-unstyled">
                        <li class="m-4">
                            <input type="radio" id="sort1" name="sort" value="name" class="d-inline">
                            <label for="sort1" class="d-inline">
                                <fmt:message key="option.name"/>
                            </label>
                        </li>
                        <li>
                            <input type="radio" id="sort2" name="sort" value="rating" class="d-inline">
                            <label for="sort2" class="d-inline">
                                <fmt:message key="option.rating"/>
                            </label>
                        </li>
                    </ul>
                </div>
                <div class="col">
                    <div class="d-flex justify-content-center">
                        <button type="submit" class="btn btn-block text-body btn-outline-primary">
                            <fmt:message key="button.sort"/>
                        </button>
                    </div>
                </div>
            </div>
        </form>
    </div>


    <div class="card-body" style="border-radius: 10px;">
        <table class="table table-striped table-hover align-middle text-center">
            <jsp:useBean id="mastersList" scope="request" type="java.util.List"/>
            <tr class="bg-light">
                <th class="col-md-4">
                    <fmt:message key="name"/>
                </th>
                <th class="col-md-4">
                    <fmt:message key="services"/>
                </th>
                <th class="col-md-4">
                    <fmt:message key="rating"/>
                </th>
            </tr>

            <c:forEach var="master" items="${mastersList}">
                <tr>
                    <td>
                        <a href="${pageContext.request.contextPath}/app?command=viewMasterInfo&id=${master.getId()}" class="text-decoration-none">
                            <c:choose>
                                <c:when test="${sessionScope.lang.equals('uk')}">
                                    ${master.fullnameUA}
                                </c:when>
                                <c:when test="${sessionScope.lang.equals('en')}">
                                    ${master.fullnameEN}
                                </c:when>
                            </c:choose>
                        </a>
                    </td>
                    <td>
                        <ul class="list-unstyled">
                            <c:forEach var="category" items="${master.categories}">
                                <li>
                                    <c:choose>
                                        <c:when test="${sessionScope.lang.equals('uk')}">
                                            ${category.nameUA}
                                        </c:when>
                                        <c:when test="${sessionScope.lang.equals('en')}">
                                            ${category.nameEN}
                                        </c:when>
                                    </c:choose>
                                </li>
                            </c:forEach>
                        </ul>
                    </td>
                    <td>
                        <c:choose>
                            <c:when test="${master.rating != 0.0}">
                                ${master.rating}
                                <span class="fa fa-star checked"></span>
                            </c:when>
                            <c:otherwise>
                                <fmt:message key="n-a"/>
                            </c:otherwise>
                        </c:choose>
                    </td>
                </tr>
            </c:forEach>

        </table>
    </div>
</div>
</body>
</html>

src/main/webapp/jsp/client/reviews-client.jsp
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ page contentType="text/html;charset=UTF-8" %>
<html>
<head>
    <fmt:setLocale value="${sessionScope.lang}"/>
    <fmt:setBundle basename="content"/>
    <title>
        <fmt:message key="reviews"/>
    </title>
    <link rel="stylesheet" href="${pageContext.request.contextPath}/css/star-rating.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
</head>
<body>
<jsp:include page="../navbar.jsp"/>
<div class="container">
    <div class="row gutters-sm">
        <div class="col-md-3 d-none d-md-block">
            <div class="card">
                <div class="card-body">
                    <nav class="nav flex-column nav-pills nav-gap-y-1">
                        <a href="${pageContext.request.contextPath}/client/account" data-toggle="tab"
                           class="nav-item nav-link has-icon nav-link-faded">
                            <fmt:message key="profile"/>
                        </a>
                        <a href="${pageContext.request.contextPath}/client/balance" data-toggle="tab"
                           class="nav-item nav-link has-icon nav-link-faded">
                            <fmt:message key="balance"/>
                        </a>
                        <a href="${pageContext.request.contextPath}/app?command=viewAppointments" data-toggle="tab"
                           class="nav-item nav-link has-icon nav-link-faded">
                            <fmt:message key="appointments"/>
                        </a>
                        <a href="${pageContext.request.contextPath}/app?command=viewReviews" data-toggle="tab"
                           class="nav-item nav-link has-icon nav-link-faded active">
                            <fmt:message key="reviews"/>
                        </a>
                    </nav>
                </div>
            </div>
        </div>
        <div class="col-md-9">
            <div class="card">
                <div class="card-body tab-content">
                    <div class="tab-pane active">
                        <div class="d-flex justify-content-center">
                            <div class="card-body p-4">
                                <jsp:useBean id="user" scope="session" type="model.Client"/>
                                <c:if test="${empty user.reviewsList}">
                                    <h4 class="text-center mt-4 mb-4">
                                        <fmt:message key="header.no-reviews.client"/>
                                    </h4>
                                </c:if>
                                <c:if test="${not empty user.reviewsList}">
                                    <div>
                                        <c:forEach var="review" items="${user.reviewsList}">
                                            <h5 class="mb-2">
                                                <fmt:message key="master"/>:
                                                <c:choose>
                                                    <c:when test="${sessionScope.lang.equals('uk')}">
                                                        ${review.master.fullnameUA}
                                                    </c:when>
                                                    <c:when test="${sessionScope.lang.equals('en')}">
                                                        ${review.master.fullnameEN}
                                                    </c:when>
                                                </c:choose>
                                            </h5>
                                            <div class="card card-body border border-1 mt-3 mb-3 pb-1">
                                                <div class="row">
                                                    <div class="col-2">
                                                        <b>
                                                            <fmt:message key="rating"/>:</b>
                                                    </div>
                                                    <div class="col-10">
                                                        <c:forEach var="point" begin="1" end="${review.rating}">
                                                            <span class="fa fa-star checked"></span>
                                                        </c:forEach>
                                                    </div>
                                                </div>
                                                <div class="row mt-3">
                                                    <div class="col-2">
                                                        <b>
                                                            <fmt:message key="review"/>:
                                                        </b>
                                                    </div>
                                                    <div class="col-10">
                                                        <p>
                                                            ${review.text}
                                                        </p>
                                                    </div>
                                                </div>
                                            </div>
                                        </c:forEach>
                                    </div>
                                </c:if>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
</body>
</html>

src/main/webapp/jsp/client/success-page.jsp
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ page contentType="text/html;charset=UTF-8" %>
<html>
<head>
    <fmt:setLocale value="${sessionScope.lang}"/>
    <fmt:setBundle basename="content"/>
    <title>
        <fmt:message key="title.success"/>
    </title>
</head>
<body>
<jsp:include page="/jsp/navbar.jsp"/>
<div class="container mt-5 p-5">
    <div class="text-center mt-5 p-5">
        <div class="justify-content-center alert alert-success" role="alert">
            <h4 class="alert-heading">
                <fmt:message key="success.alert-heading"/>
            </h4>
            <p>
                <fmt:message key="success.info"/>
            </p>
            <hr>
            <a href="${pageContext.request.contextPath}/app?command=viewServices">
                <fmt:message key="button.check-other-services"/>
            </a>
        </div>
    </div>
</div>
</body>
</html>